﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using DlhSoft.Windows.Data;
using System.Data;

namespace ScheduleChartResourceListViewCustomTableDataBindingSample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            ObservableCollection<ResourceItem> resourceItems = new ObservableCollection<ResourceItem>
            {
                new ResourceItem { Content = "Resource 1", CostPerUsage = 100, CostPerHour = 10 },
                new ResourceItem { Content = "Resource 2", CostPerHour = 20 },
                new ResourceItem { Content = "Resource 3", CostPerHour = 20 }
            };

            for (int i = 4; i <= 16; i++)
                resourceItems.Add(new ResourceItem { Content = "Resource " + i });

            // Prepare the assignable task data table.
            DataTable assignableTaskItems = new DataTable();
            assignableTaskItems.Columns.Add("DisplayName");
            assignableTaskItems.Columns.Add("IndentLevel", typeof(int));
            assignableTaskItems.Columns.Add("StartDate", typeof(DateTime));
            assignableTaskItems.Columns.Add("WorkEffort", typeof(TimeSpan));
            assignableTaskItems.Columns.Add("CompletedWorkEffort", typeof(TimeSpan));
            assignableTaskItems.Columns.Add("IsWorkCompleted", typeof(bool));
            assignableTaskItems.Columns.Add("IsMilestoneTask", typeof(bool));
            assignableTaskItems.Columns.Add("AssignedResources");
            assignableTaskItems.Columns.Add("TaskIndex");
            assignableTaskItems.Columns.Add("PredecessorTaskIndexes");
            assignableTaskItems.Columns.Add("TaskCost", typeof(double));
            assignableTaskItems.Columns.Add("Description");
            assignableTaskItems.Rows.Add("Task 1", 0, DateTime.MinValue, TimeSpan.Zero, TimeSpan.Zero, false, false, null, "1", null, 0, "Description of Task 1");
            assignableTaskItems.Rows.Add("Task 1.1", 1, DateTime.Today, TimeSpan.Parse("08:00:00"), TimeSpan.Parse("04:00:00"), false, false, null, "2", null, 0, "Description of Task 1.1");
            assignableTaskItems.Rows.Add("Task 1.2", 1, DateTime.MinValue, TimeSpan.Zero, TimeSpan.Zero, false, false, null, "3", null, 0, "Description of Task 1.2");
            assignableTaskItems.Rows.Add("Task 1.2.1", 2, DateTime.Today, TimeSpan.Parse("08:00:00"), TimeSpan.Zero, false, false, null, "4", null, 0, "Description of Task 1.2.1");
            assignableTaskItems.Rows.Add("Task 1.2.2", 2, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, false, false, null, "5", null, 0, "Description of Task 1.2.2");
            assignableTaskItems.Rows.Add("Task 2", 0, DateTime.MinValue, TimeSpan.Zero, TimeSpan.Zero, false, false, null, "6", null, 0, "Description of Task 2");
            assignableTaskItems.Rows.Add("Task 2.1", 1, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, true, false, null, "7", null, 0, "Description of Task 2.1");
            assignableTaskItems.Rows.Add("Task 2.2", 1, DateTime.Today, TimeSpan.Parse("08:00:00"), TimeSpan.Parse("06:00:00"), false, false, null, "8", null, 0, "Description of Task 2.2");
            assignableTaskItems.Rows.Add("Task 2.3", 1, DateTime.MinValue, TimeSpan.Zero, TimeSpan.Zero, false, false, null, "9", "8", 0, "Description of Task 2.3");
            assignableTaskItems.Rows.Add("Task 2.3.1", 2, DateTime.Today, TimeSpan.Parse("1.16:00:00"), TimeSpan.Zero, false, false, null, "10", null, 2000, "Description of Task 2.3.1");
            assignableTaskItems.Rows.Add("Task 2.3.2", 2, DateTime.Today, TimeSpan.Parse("08:00:00"), TimeSpan.Zero, false, false, null, "11", "10", 0, "Description of Task 2.3.2");
            assignableTaskItems.Rows.Add("Task 3", 0, DateTime.Today, TimeSpan.Parse("12:30:00"), TimeSpan.Parse("02:30:00"), false, false, null, "12", "9, 11SS+12", 0, "Description of Task 3");
            assignableTaskItems.Rows.Add("Task 4", 0, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, false, false, "Resource 1", "13", null, 0, "Description of Task 4");
            assignableTaskItems.Rows.Add("Task 5", 0, DateTime.Today, TimeSpan.Parse("20:00:00"), TimeSpan.Zero, false, false, "Resource 1, Resource 2 [50%]", "14", null, 0, "Description of Task 5");
            assignableTaskItems.Rows.Add("Task 6", 0, DateTime.Today, TimeSpan.Zero, TimeSpan.Zero, false, true, null, "15", "14+2", 0, "Description of Task 6");
            assignableTaskItems.Rows.Add("Task 7", 0, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Parse("08:00:00"), false, false, "Resource 1", "16", "15+2", 0, "Description of Task 7");
            assignableTaskItems.Rows.Add("Task 8", 0, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, false, false, "Resource 1", "17", "16", 0, "Description of Task 8");
            assignableTaskItems.Rows.Add("Task 9", 0, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, false, false, "Resource 2", "18", "16", 0, "Description of Task 9");
            assignableTaskItems.Rows.Add("Task 10", 0, DateTime.Today, TimeSpan.Parse("16:00:00"), TimeSpan.Zero, false, false, "Resource 2, Resource 3 [75%]", "19", "18", 0, "Description of Task 10");

            // TaskMemberPath properties are set to the appropriate member column names for the data table in markup.
            // Use the DefaultView property of the data table to get an IEnumerable data collection.
            ScheduleChartResourceListView.ItemsSource = resourceItems;
            ScheduleChartResourceListView.AssignableTaskItemsSource = assignableTaskItems.DefaultView;
        }
    }
}
